package forktest;

import java.util.ArrayList;
import java.util.Iterator;
import java.util.List;

import org.jbpm.graph.def.Node;
import org.jbpm.graph.exe.Token;

public class JbpmStateManager
{
	private static JbpmStateManager instance = new JbpmStateManager();
	private static List<JbpmStateManagerSubscriber> subscribers = new ArrayList<JbpmStateManagerSubscriber>();
	
	private JbpmStateManager()
	{
	}
	
	public static JbpmStateManager getInstance()
	{
		return instance;
	}
	
	public void subscribe(JbpmStateManagerSubscriber subscriber)
	{
		subscribers.add(subscriber);
	}
    
    public void EnterState(Node node, Token token)
    {
        Iterator<JbpmStateManagerSubscriber> itr = subscribers.iterator();
        while(itr.hasNext())
        {
            itr.next().enterState(node.getName(), token);
        }
    }
}
